Package de.willuhn.jameica.hbci.server

# Class TurnusImpl

java.lang.Object
java.rmi.server.RemoteObject
java.rmi.server.RemoteServer
java.rmi.server.UnicastRemoteObject
de.willuhn.datasource.db.AbstractDBObject
de.willuhn.jameica.hbci.server.AbstractHibiscusDBObject
de.willuhn.jameica.hbci.server.TurnusImpl

All Implemented Interfaces:
  `de.willuhn.datasource.GenericObject`, `de.willuhn.datasource.rmi.Changeable`, `de.willuhn.datasource.rmi.DBObject`, `de.willuhn.datasource.rmi.Transactionable`, `Checksum`, `HibiscusDBObject`, `Turnus`, `Serializable`, `Remote`

public class TurnusImpl extends AbstractHibiscusDBObject implements Turnus
Implementierung eines Zahlungs-Turnus fuer Geld-Transfers.

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class java.rmi.server.RemoteObject

`ref`

### Fields inherited from interface de.willuhn.jameica.hbci.rmi.Turnus

`ZEITEINHEIT_MONATLICH, ZEITEINHEIT_WOECHENTLICH`

## Constructor Summary

Constructors
Constructor
Description
`TurnusImpl()`
ct.

## Method Summary

Modifier and Type
Method
Description
`protected void`
`deleteCheck()`
`Object`
`getAttribute(String arg0)`
Ueberschrieben, um ein virtuelles Attribut "bezeichnung" zu schaffen.
`String`
`getBezeichnung()`
Liefert eine sprechende Bezeichnung des Intervalls.
`long`
`getChecksum()`
Liefert die Checksumme des Objektes.
`int`
`getIntervall()`
Liefert die Anzahl der Intervalle zwischen den Zahlungen.
`String`
`getPrimaryAttribute()`
`protected String`
`getTableName()`
`int`
`getTag()`
Liefert den Tag, an dem die Zahlung innerhalb der Zeiteinheit ausgefuehrt werden soll.
`int`
`getZeiteinheit()`
Liefert eine Konstante fuer die Zeiteinheit.
`void`
`insert()`
Ueberschrieben, um zu pruefen, ob ein Turnus mit diesen Eigenschaften vielleicht schon existiert.
`protected void`
`insertCheck()`
`boolean`
`isInitial()`
Liefert `true` wenn es sich bei dem Turnus um Initial-Daten von Hibiscus handelt, die nicht geloescht werden koennen.
`void`
`setIntervall(int intervall)`
Speichert die Anzahl der Intervalle zwischen den Zahlungen.
`void`
`setTag(int tag)`
Speichert den Tag, an dem die Zahlung innerhalb der Zeiteinheit ausgefuehrt werden soll.
`void`
`setZeiteinheit(int zeiteinheit)`
Speichert die Zeiteinheit.
`protected void`
`updateCheck()`

### Methods inherited from class de.willuhn.jameica.hbci.server.AbstractHibiscusDBObject

`delete, getMeta, setMeta, store`

### Methods inherited from class de.willuhn.datasource.db.AbstractDBObject

`addDeleteListener, addStoreListener, clear, equals, getAttributeNames, getAttributeType, getForeignObject, getID, getIDField, getInsertSQL, getList, getListQuery, getLoadQuery, getService, getUpdateSQL, hasChanged, hasChanged, init, isNewObject, load, overwrite, removeDeleteListener, removeStoreListener, setAttribute, setID, setService, transactionBegin, transactionCommit, transactionRollback`

### Methods inherited from class java.rmi.server.UnicastRemoteObject

`clone, exportObject, exportObject, exportObject, exportObject, exportObject, unexportObject`

### Methods inherited from class java.rmi.server.RemoteServer

`getClientHost, getLog, setLog`

### Methods inherited from class java.rmi.server.RemoteObject

`equals, getRef, hashCode, toString, toStub`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface de.willuhn.datasource.rmi.Changeable

`clear, delete, isNewObject, overwrite, store`

### Methods inherited from interface de.willuhn.datasource.rmi.DBObject

`addDeleteListener, addStoreListener, equals, getAttributeType, getList, load, removeDeleteListener, removeStoreListener`

### Methods inherited from interface de.willuhn.datasource.GenericObject

`getAttributeNames, getID`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.HibiscusDBObject

`getMeta, setMeta`

### Methods inherited from interface de.willuhn.datasource.rmi.Transactionable

`transactionBegin, transactionCommit, transactionRollback`

## Constructor Details

### TurnusImpl

public TurnusImpl() throws RemoteException
ct.

Throws:
  `RemoteException`

## Method Details

### getTableName

protected String getTableName()

Specified by:
  `getTableName` in class `de.willuhn.datasource.db.AbstractDBObject`
See Also:
  - `AbstractDBObject.getTableName()`

### getPrimaryAttribute

public String getPrimaryAttribute() throws RemoteException

Specified by:
  `getPrimaryAttribute` in interface `de.willuhn.datasource.rmi.DBObject`
Specified by:
  `getPrimaryAttribute` in interface `de.willuhn.datasource.GenericObject`
Specified by:
  `getPrimaryAttribute` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.getPrimaryAttribute()`

### deleteCheck

protected void deleteCheck() throws de.willuhn.util.ApplicationException

Overrides:
  `deleteCheck` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `de.willuhn.util.ApplicationException`
See Also:
  - `AbstractDBObject.deleteCheck()`

### insertCheck

protected void insertCheck() throws de.willuhn.util.ApplicationException

Overrides:
  `insertCheck` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `de.willuhn.util.ApplicationException`
See Also:
  - `AbstractDBObject.insertCheck()`

### updateCheck

protected void updateCheck() throws de.willuhn.util.ApplicationException

Overrides:
  `updateCheck` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `de.willuhn.util.ApplicationException`
See Also:
  - `AbstractDBObject.updateCheck()`

### getBezeichnung

public String getBezeichnung() throws RemoteException
Description copied from interface: `Turnus`
Liefert eine sprechende Bezeichnung des Intervalls.

Specified by:
  `getBezeichnung` in interface `Turnus`
Returns:
  Bezeichnung des Intervalls.
Throws:
  `RemoteException`
See Also:
  - `Turnus.getBezeichnung()`

### getIntervall

public int getIntervall() throws RemoteException
Description copied from interface: `Turnus`
Liefert die Anzahl der Intervalle zwischen den Zahlungen. Beispiele:

- Zahlung wochentlich: Intervall = `1`, Zeiteinheit = `ZEITEINHEIT_WOECHENTLICH`
- Zahlung alle 2 Wochen: Intervall = `2`, Zeiteinheit = `ZEITEINHEIT_WOECHENTLICH`
- Vierteljaehrlich (quartalsweise): Intervall = `3`, Zeiteinheit = `ZEITEINHEIT_MONATLICH`
- Jaehrlich: Intervall = `12`, Zeiteinheit = `ZEITEINHEIT_MONATLICH`

Specified by:
  `getIntervall` in interface `Turnus`
Returns:
  Anzahl der Intervalle zwischen den Zahlungen.
Throws:
  `RemoteException`
See Also:
  - `Turnus.getIntervall()`

### setIntervall

public void setIntervall(int intervall) throws RemoteException
Description copied from interface: `Turnus`
Speichert die Anzahl der Intervalle zwischen den Zahlungen.

Specified by:
  `setIntervall` in interface `Turnus`
Parameters:
  `intervall` - Anzahl der Intervalle.
Throws:
  `RemoteException`
See Also:
  - `Turnus.setIntervall(int)`

### getZeiteinheit

public int getZeiteinheit() throws RemoteException
Description copied from interface: `Turnus`
Liefert eine Konstante fuer die Zeiteinheit. Ist der Rueckgabewert = `ZEITEINHEIT_WOECHENTLICH`, dann wird woechentlich oder zu einem Vielfachen einer Woche gezahlt.
Bei einem Rueckgabewert = `ZEITEINHEIT_MONATLICH` wird monatlich oder einem Vielfachen eines Monats gezahlt.

Specified by:
  `getZeiteinheit` in interface `Turnus`
Returns:
  Zeiteinheit.
Throws:
  `RemoteException`
See Also:
  - `Turnus.getZeiteinheit()`

### setZeiteinheit

public void setZeiteinheit(int zeiteinheit) throws RemoteException
Description copied from interface: `Turnus`
Speichert die Zeiteinheit.

Specified by:
  `setZeiteinheit` in interface `Turnus`
Parameters:
  `zeiteinheit` - Kann einen der beiden Werte `ZEITEINHEIT_WOECHENTLICH` oder `ZEITEINHEIT_MONATLICH` besitzen.
Throws:
  `RemoteException`
See Also:
  - `Turnus.setZeiteinheit(int)`

### getTag

public int getTag() throws RemoteException
Description copied from interface: `Turnus`
Liefert den Tag, an dem die Zahlung innerhalb der Zeiteinheit ausgefuehrt werden soll.

Specified by:
  `getTag` in interface `Turnus`
Returns:
  Tag, an dem die Zahlung erfolgt. Handelt es sich um eine monatliche Zahlung (`ZEITEINHEIT_MONATLICH`), kann der Wert zwischen 1 und 31 liegen (Tage des Monats). Bei woechentlicher Zahlung (`ZEITEINHEIT_WOECHENTLICH`), wird ein Wert zwischen 1 und 7 zurueckgeliefert (Wochentag) wobei 1 Montag ist und 7 demzufolge Sonntag.
Throws:
  `RemoteException`
See Also:
  - `Turnus.getTag()`

### setTag

public void setTag(int tag) throws RemoteException
Description copied from interface: `Turnus`
Speichert den Tag, an dem die Zahlung innerhalb der Zeiteinheit ausgefuehrt werden soll.

Specified by:
  `setTag` in interface `Turnus`
Parameters:
  `tag` - Tag, an dem die Zahlung erfolgt.
Throws:
  `RemoteException`
See Also:
  - `Turnus.setTag(int)`

### isInitial

public boolean isInitial() throws RemoteException
Description copied from interface: `Turnus`
Liefert `true` wenn es sich bei dem Turnus um Initial-Daten von Hibiscus handelt, die nicht geloescht werden koennen.

Specified by:
  `isInitial` in interface `Turnus`
Returns:
  true, wenn der Datensatz nicht geloescht werden kann.
Throws:
  `RemoteException`
See Also:
  - `Turnus.isInitial()`

### getChecksum

public long getChecksum() throws RemoteException
Description copied from interface: `Checksum`
Liefert die Checksumme des Objektes.

Specified by:
  `getChecksum` in interface `Checksum`
Returns:
  Checksumme.
Throws:
  `RemoteException`
See Also:
  - `Checksum.getChecksum()`

### getAttribute

public Object getAttribute(String arg0) throws RemoteException
Ueberschrieben, um ein virtuelles Attribut "bezeichnung" zu schaffen.

Specified by:
  `getAttribute` in interface `de.willuhn.datasource.rmi.DBObject`
Specified by:
  `getAttribute` in interface `de.willuhn.datasource.GenericObject`
Overrides:
  `getAttribute` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.getAttribute(java.lang.String)`

### insert

public void insert() throws RemoteException, de.willuhn.util.ApplicationException
Ueberschrieben, um zu pruefen, ob ein Turnus mit diesen Eigenschaften vielleicht schon existiert. Ist dies der Fall, ignoriert die Funktion das Speichern und kehrt fehlerfrei zurueck.

Overrides:
  `insert` in class `de.willuhn.datasource.db.AbstractDBObject`
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`
See Also:
  - `AbstractDBObject.insert()`